package addressbook;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

/**
 * ϿץꥱǡŪ˻Ȥؿ饹
 */
public class AddressbookUtils {

		/**
		 * JAXP DocumentBuilderƤӽФ
		 * @return DocumentBuilder
		 */
		public static DocumentBuilder getDocumentBuilder() {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			dbf.setValidating(false);
			dbf.setIgnoringElementContentWhitespace(true);
			DocumentBuilder db;
			try {
				return dbf.newDocumentBuilder();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		/**
		 * ʸ󤫤DOM Document
		 * @param xmlData XMLʸ
		 * @return DOM Document
		 */
		public static Document loadXMLFromString(String xmlData) {
			DocumentBuilder db = getDocumentBuilder();
			try {
				return db.parse(new InputSource(new StringReader(xmlData)));
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}
		}
		
		/**
		 * ꤷ̾ĻҥΡɤ֤
		 * @param parents Node
		 * @param tagName String
		 * @return
		 */
	    public static Node getChildNodeByTagName(Node parents, String tagName) {
			Node child = null;
			NodeList childlen = parents.getChildNodes();
			//ҥΡɤο
			int len = (childlen != null) ? childlen.getLength() : 0;
			for (int i = 0; i < len; i++) {
				Node tmpchild = childlen.item(i);
				// ̾tagNameƱǤФΥΡɤ֤
				if (tmpchild.getNodeName().equals(tagName)) {
					child = tmpchild;
					break;
				}
			}
			return child;	
		}

}
