package addressbook;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class SearchAddressbookBean {

	ConnectXprioriBean xcon = null; // ConnectXprioriBean饹

	/**
	 * 󥹥ȥ饯 ConnectXprioriBean饹ƤӽФXprioriȤ³Ω
	 */
	public SearchAddressbookBean() {
		// XprioriȤ³Ω
		xcon = new ConnectXprioriBean();
	}

	/**
	 * ƥ
	 * 
	 * @return ƥ
	 */
	public int CountAllItem() {
		// ƥν
		int item_num = 0;
		// ƥXPath
		String xpath = "count(/ND/address_book/item)";
		// ̤
		String tmpItem_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(tmpItem_xml);

		/*
		 * ̤Ȥ 
		 * <?xml version="1.0" encoding="UTF-8" ?>
		 * <Query-Results>
		 * 100
		 * </Query-Results>
		 * Ȥ(\n)äʸ֤äƤΤǡ
		 * Query-ResultsǤͤ\nͤ
		 */
		Element element = (Element) doc.getElementsByTagName("Query-Results")
				.item(0);
		String nodevalue = element.getFirstChild().getNodeValue().replace("\n",	"");
		// ʸ󤫤ͤ˥㥹Ȥ
		item_num = Integer.parseInt(nodevalue);
		return item_num;
	}

	/**
	 * ƥꤷ֤顢եåʬ
	 * 
	 * @param start
	 *            ֹ
	 * @param offset
	 *            եå
	 * @return ItemBean
	 */
	public ItemBean[] getItems(int start, int offset) {
		// եåʬItemBean
		ItemBean[] items = new ItemBean[offset];

		// XPathξĤ
		String xpathCondition = "position() >= " + start + " and "
				+ "position() < " + (start + offset);

		// ꤷϰϤΰiitemΡɤXPath䤤碌̤
		String itemsXML = xcon.query("/ND/address_book/item[" + xpathCondition
				+ "]");
		
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(itemsXML);
		NodeList itemnodeList = doc.getElementsByTagName("item");
		for (int i = 0; i < itemnodeList.getLength(); i++) {
			items[i] = new ItemBean(itemnodeList.item(i));
		}
		return items;
	}

	/**
	 * ꤷIDĥƥ
	 * 
	 * @param id
	 * @return ItemBean
	 */
	public ItemBean getItemById(String id) {
		// idƱID°ͤitemΡɤXPath䤤碌̤
		String itemXML = xcon.query("/ND/address_book/item[@id = " + id + "]");
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(itemXML);
		// DOM DocumentƬitemΡɤФItemBean
		ItemBean item = new ItemBean(doc.getElementsByTagName("item").item(0));
		return item;
	}

	/**
	 * Ȥ
	 * 
	 */
	public void logout() {
		xcon.logout();
	}

}
